// $Id: CropPage.java 16027 2012-07-13 11:18:01Z mike $

package org.faceless.pdf2.viewer2.feature;

import org.faceless.pdf2.viewer2.*;
import org.faceless.pdf2.viewer2.*;
import org.faceless.pdf2.*;
import java.awt.*;
import java.awt.geom.*;
import javax.swing.undo.*;
import javax.swing.*;
import javax.swing.event.*;

public class CropPage extends ViewerFeature implements AreaSelectionAction {
    
    public CropPage() {
        super("CropPage");
    }

    public String getDescription() {
        return UIManager.getString("PDFViewer.Crop");
    }

    public void selectArea(final PagePanel panel, final Rectangle2D r) {
        final PDFPage page = panel.getPage();
        final float[] orig = page.getBox("CropBox");
        page.setBox("CropBox", (float)r.getMinX(), (float)r.getMinY(), (float)r.getMaxX(), (float)r.getMaxY());

        panel.getDocumentPanel().fireUndoableEditEvent(new UndoableEditEvent(panel.getDocumentPanel(), new AbstractUndoableEdit() {
            public String getPresentationName() {
                return getDescription();
            }
            public void undo() {
                super.undo();
                page.setBox("CropBox", orig[0], orig[1], orig[2], orig[3]);
            }
            public void redo() {
                super.redo();
                page.setBox("CropBox", (float)r.getMinX(), (float)r.getMinY(), (float)r.getMaxX(), (float)r.getMaxY());
            }
        }));
    }

}
